--
-- Dirty Tire Tracks for FS19
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0.0.0 - 2020-08-31 - first release
-- @history:	v1.1.0.0 - 2020-11-04 - added settings menu and some other feautures
--
DirtyTireTracks = {}
DirtyTireTracks.confDir = getUserProfileAppPath().. "modsSettings/DirtyTireTracks/"
DirtyTireTracks.modDirectory = g_currentModDirectory
DirtyTireTracks.vehicles = {}
DirtyTireTracks.vehiclesCount = 0
DirtyTireTracks.deletedOnSaveGame = false
DirtyTireTracks.restoredOnSaveGame = false

DirtyTireTracks.durations = { 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 30, 36, 4, 48 }
DirtyTireTracks.wetDepends = { true, false }
DirtyTireTracks.minWetFactors = { 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1 }
DirtyTireTracks.sizeFactors = { 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9, 2 }
DirtyTireTracks.activeOnFields = { true, false }
DirtyTireTracks.saveTrackss = { true, false }
DirtyTireTracks.currentConfigs = { true, false }

DirtyTireTracks.durationTexts = { 'Forever', '0.1', '0.2', '0.3', '0.4', '0.5', '0.6', '0.7', '0.8', '0.9', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23', '24', '30', '36', '42', '48'}
DirtyTireTracks.wetDependTexts = { 'On', 'Off' }
DirtyTireTracks.minWetFactorTexts = { '0', '10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%' }
DirtyTireTracks.sizeFactorTexts = {  '0', '10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%', '110%', '120%', '130%', '140%', '150%', '160%', '170%', '180%', '190%', '200%' }
DirtyTireTracks.activeOnFieldTexts = { 'On', 'Off' }
DirtyTireTracks.saveTracksTexts = { 'On', 'Off' }
DirtyTireTracks.currentConfigTexts = { 'On', 'Off' }

DirtyTireTracks.duration = 6
DirtyTireTracks.wetDepend = true
DirtyTireTracks.minWetFactor = 0
DirtyTireTracks.sizeFactor = 1
DirtyTireTracks.activeOnField = false
DirtyTireTracks.saveTracks = true

DirtyTireTracks.durationIndex = 16
DirtyTireTracks.wetDependIndex = 1
DirtyTireTracks.minWetFactorIndex = 1
DirtyTireTracks.sizeFactorIndex = 11
DirtyTireTracks.activeOnFieldIndex = 2
DirtyTireTracks.saveTracksIndex = 1

function getIndexFromElement(table, element)
	for index, el in pairs(table) do
		if type(element) == 'number' then
			if string.format("%.2f", element) == string.format("%.2f", el) then
				return index
			end
		else
			if element == el then
				return index
			end
		end
	end
	return false
end
function floatToString(num)
	local str = string.gsub(string.format('%.3f', num), "%.", "")
	return str
end
function stringToFloat(str)
	local num1 = string.sub(str, 1, -4)
	local num2 = string.sub(str, -3, -1)
	local num = num1 .. '.' .. num2
	local number = tonumber(num)
	return number
end
function DirtyTireTracks.prerequisitesPresent(specializations)
	return true
end
function DirtyTireTracks.registerOverwrittenFunctions(vehicleType)
	SavegameController.saveSavegame = Utils.prependedFunction(SavegameController.saveSavegame, DirtyTireTracks.saveSavegameNew)
	SavegameController.onSaveComplete = Utils.appendedFunction(SavegameController.onSaveComplete, DirtyTireTracks.onSaveCompletNew)
end
function DirtyTireTracks:saveSavegameNew()
	if DirtyTireTracks.duration ~= 0 then
		DirtyTireTracks:deleteTireTracks(true)
	end
end
function DirtyTireTracks:onSaveCompletNew()
	if DirtyTireTracks.duration ~= 0 then
		DirtyTireTracks:restoreTireTracks()
	end
end
function DirtyTireTracks:settingsFromGui(vehicle, durationState, wetDependState, minWetFactorState, sizeFactorState, activeOnFieldState, saveTracksState, 
											currentConfigState, durationCurrentState, wetDependCurrentState, minWetFactorCurrentState, sizeFactorCurrentState, activeOnFieldCurrentState)
	local spec = vehicle.spec_dirtyTireTracks
	
	if DirtyTireTracks.durationIndex ~= durationState or DirtyTireTracks.wetDependIndex ~= wetDependState or DirtyTireTracks.minWetFactorIndex ~= minWetFactorState or DirtyTireTracks.sizeFactorIndex ~= sizeFactorState
	or DirtyTireTracks.activeOnFieldIndex ~= activeOnFieldState or DirtyTireTracks.saveTracksIndex ~= saveTracksState then
		vehicle:setGlobalConfig(DirtyTireTracks.durations[durationState],  DirtyTireTracks.wetDepends[wetDependState], DirtyTireTracks.minWetFactors[minWetFactorState], DirtyTireTracks.sizeFactors[sizeFactorState],
				DirtyTireTracks.activeOnFields[activeOnFieldState], DirtyTireTracks.saveTrackss[saveTracksState], false)
	end
	
	if spec.currentConfigIndex ~= currentConfigState or spec.durationIndex ~= durationCurrentState or spec.wetDependIndex ~= wetDependCurrentState or spec.minWetFactorIndex ~= minWetFactorCurrentState or spec.sizeFactorIndex ~= sizeFactorCurrentState
	or spec.activeOnFieldIndex ~= activeOnFieldCurrentState then
		vehicle:setVehicleConfig(DirtyTireTracks.currentConfigs[currentConfigState], DirtyTireTracks.durations[durationCurrentState],  DirtyTireTracks.wetDepends[wetDependCurrentState], DirtyTireTracks.minWetFactors[minWetFactorCurrentState], DirtyTireTracks.sizeFactors[sizeFactorCurrentState],
				DirtyTireTracks.activeOnFields[activeOnFieldCurrentState], false)
	end
end
function DirtyTireTracks:settingsResetGui()
	DirtyTireTracks.gui.dtrSettingGui:setDuration(16)
	DirtyTireTracks.gui.dtrSettingGui:setWetDepend(1)
	DirtyTireTracks.gui.dtrSettingGui:setMinWetFactor(1)
	DirtyTireTracks.gui.dtrSettingGui:setSizeFactor(11)
	DirtyTireTracks.gui.dtrSettingGui:setActiveOnField(2)
	DirtyTireTracks.gui.dtrSettingGui:setSaveTracks(1)
	
	DirtyTireTracks.gui.dtrSettingGui:setCurrentConfig(2)
	
	DirtyTireTracks.gui.dtrSettingGui:setDurationCurrent(16)
	DirtyTireTracks.gui.dtrSettingGui:setWetDependCurrent(1)
	DirtyTireTracks.gui.dtrSettingGui:setMinWetFactorCurrent(1)
	DirtyTireTracks.gui.dtrSettingGui:setSizeFactorCurrent(11)
	DirtyTireTracks.gui.dtrSettingGui:setActiveOnFieldCurrent(2)
end
function DirtyTireTracks:guiClosed()
	DirtyTireTracks.gui.dtrSettingGui:setDuration(DirtyTireTracks.durationIndex)
	DirtyTireTracks.gui.dtrSettingGui:setWetDepend(DirtyTireTracks.wetDependIndex)
	DirtyTireTracks.gui.dtrSettingGui:setMinWetFactor(DirtyTireTracks.minWetFactorIndex)
	DirtyTireTracks.gui.dtrSettingGui:setSizeFactor(DirtyTireTracks.sizeFactorIndex)
	DirtyTireTracks.gui.dtrSettingGui:setActiveOnField(DirtyTireTracks.activeOnFieldIndex)
	DirtyTireTracks.gui.dtrSettingGui:setSaveTracks(DirtyTireTracks.saveTracksIndex)
end
function DirtyTireTracks.registerFunctions(vehicleType)
	SpecializationUtil.registerFunction(vehicleType, "groundRaycastCallbackNew", 			DirtyTireTracks.groundRaycastCallbackNew)
	SpecializationUtil.registerFunction(vehicleType, "toggleActiveDirtyTireTracks", 		DirtyTireTracks.toggleActiveDirtyTireTracks)
	SpecializationUtil.registerFunction(vehicleType, "getHasDttImplement", 					DirtyTireTracks.getHasDttImplement)
	SpecializationUtil.registerFunction(vehicleType, "activateDttMod", 						DirtyTireTracks.activateDttMod)
	SpecializationUtil.registerFunction(vehicleType, "saveToXmlDirtyTireTracks", 			DirtyTireTracks.saveToXmlDirtyTireTracks)
	SpecializationUtil.registerFunction(vehicleType, "loadFromXmlDirtyTireTracks", 			DirtyTireTracks.loadFromXmlDirtyTireTracks)
	SpecializationUtil.registerFunction(vehicleType, "saveTracksToXML", 					DirtyTireTracks.saveTracksToXML)
	SpecializationUtil.registerFunction(vehicleType, "loadTracksFromXML", 					DirtyTireTracks.loadTracksFromXML)
	SpecializationUtil.registerFunction(vehicleType, "setGlobalConfig", 					DirtyTireTracks.setGlobalConfig)
	SpecializationUtil.registerFunction(vehicleType, "setVehicleConfig", 					DirtyTireTracks.setVehicleConfig)
	SpecializationUtil.registerFunction(vehicleType, "dttGetFullName", 						DirtyTireTracks.dttGetFullName)
	SpecializationUtil.registerFunction(vehicleType, "deleteTireTracks", 					DirtyTireTracks.deleteTireTracks)
	SpecializationUtil.registerFunction(vehicleType, "deleteTireTracksCurrent", 			DirtyTireTracks.deleteTireTracksCurrent)
	SpecializationUtil.registerFunction(vehicleType, "restoreTireTracks", 					DirtyTireTracks.restoreTireTracks)
	SpecializationUtil.registerFunction(vehicleType, "createTracksFile", 					DirtyTireTracks.createTracksFile)
end
function DirtyTireTracks:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	if spec.event_IDs == nil then
		spec.event_IDs = {}
	else
		self:clearActionEventsTable(spec.event_IDs)
	end
	if self:getIsActive() and (self:getIsActiveForInput() or not self:getHasDttImplement()) and (not self:getIsAIActive() or (self.getIsControlled ~= nil and self:getIsControlled())) then
		self:loadFromXmlDirtyTireTracks(self:dttGetFullName())
		if g_dedicatedServerInfo ~= nil then
			return
		end
		local actions = { InputAction.DIRTYTIRETRACK_ACTIVATE, InputAction.DIRTYTIRETRACK_ACTIVATE_ALL, InputAction.DIRTYTIRETRACK_OPEN_MENU }
		for _,actionName in pairs(actions) do
			local always = false
			local _, eventID = g_inputBinding:registerActionEvent(actionName, self, DirtyTireTracks.actionCallback, true, true, always, true)
			spec.event_IDs[actionName] = eventID
			if g_inputBinding ~= nil and g_inputBinding.events ~= nil and g_inputBinding.events[eventID] ~= nil then
				if actionName == 'something with lower priority' then
					g_inputBinding:setActionEventTextPriority(eventID, GS_PRIO_NORMAL)
				else
					g_inputBinding:setActionEventTextPriority(eventID, GS_PRIO_VERY_HIGH)
				end
				g_inputBinding:setActionEventTextVisibility(eventID, DirtyTireTracks.showHelp)
			end
			local colliding = false
			_, colliding, _ = g_inputBinding:checkEventCollision(actionName)
			if colliding then
				if g_inputBinding.nameActions[actionName].bindings[1] ~= nil then
					if g_inputBinding.nameActions[actionName].bindings[1].inputString ~= nil then
						print(string.format('Warning: DirtyTireTracks got a colliding input action: %s', actionName)..' ('..g_inputBinding.nameActions[actionName].bindings[1].inputString..'). You can remap it in controls settings')
					end
				else
					print(string.format('Warning: DirtyTireTracks got a colliding input action: %s', actionName))
				end
			end
		end
	end
end
function DirtyTireTracks.registerEventListeners(vehicleType)
	for _,n in pairs( { "onLoad", "onPostLoad", "onPreDelete", "onUpdate", "onUpdateTick", "onRegisterActionEvents", "toggleActiveDirtyTireTracks", "activateDttMod", "setGlobalConfig", "setVehicleConfig", "onReadStream", "onWriteStream", "saveToXmlDirtyTireTracks",
						"loadFromXmlDirtyTireTracks"} ) do
		SpecializationUtil.registerEventListener(vehicleType, n, DirtyTireTracks)
	end
end
function DirtyTireTracks:onLoad(savegame)
	
    if self.isClient then
		if DirtyTireTracks.gui == nil then
			g_gui:loadProfiles(DirtyTireTracks.modDirectory .. "gui/guiProfiles.xml")
			DirtyTireTracks.gui = {}
			DirtyTireTracks.gui["dtrSettingGui"] = dtrGui:new()
			g_gui:loadGui(DirtyTireTracks.modDirectory .. "gui/dtrGui.xml", "dtrGui", DirtyTireTracks.gui.dtrSettingGui);
		end
	end
	
	self.spec_dirtyTireTracks = {}
	local spec = self.spec_dirtyTireTracks
	
	DirtyTireTracks.showHelp = true
	DirtyTireTracks.modActive = true
	spec.event_IDs = {}
	spec.modInitialized = false
	spec.modAllowed = false
	spec.modActive = true
	spec.groundRaycastResult = {}
    spec.groundRaycastResult.y = 0.0
    spec.groundRaycastResult.object = nil
    spec.groundRaycastResult.distance = 0.0
	spec.tireTracks = {}
	spec.index = 1
	spec.index2 = 1
	spec.indexSave = 1
	
	spec.currentConfig = false
	spec.duration = 6
	spec.wetDepend = true
	spec.minWetFactor = 0
	spec.sizeFactor = 1
	spec.activeOnField = false
	spec.saveTracks = true
	
	spec.currentConfigIndex = 2
	spec.durationIndex = 16
	spec.wetDependIndex = 1
	spec.minWetFactorIndex = 1
	spec.sizeFactorIndex = 11
	spec.activeOnFieldIndex = 2

	--spec.width = 0
	--spec.groundWetness = 0
	spec.trackToSaveIndex = 0
	spec.trackId = 1
	spec.tracksToTable = 500
	spec.lastWorldX = -4000
	spec.lastWorldZ = -4000
	spec.fromSavegame = false
	
	if self.spec_wheels ~= nil and self.spec_wheels.wheels ~= nil then
		spec.modInitialized = true
	end
	if not spec.modInitialized then
		print("Error: DirtyTireTracks initialization failed for "..tostring(self:dttGetFullName()).." !")
		return
	end
	local hasTireTracks = false
	local hasParticles = false
	local count = 0
	for _,wheel in pairs(self.spec_wheels.wheels) do
		if wheel.hasTireTracks then
			hasTireTracks = true
		end
		if wheel.hasParticles then
			hasParticles = true
		end
		count = count + 1
	end
	if (hasTireTracks or hasParticles) and count > 0 then
		spec.modAllowed = true
	end
	--spec.infoText = ''
	--spec.infoText2 = ''
	--spec.infoText3 = ''
	spec.timer = 0
	spec.timerErase = 0
	spec.timerSave = 250
	
	if self.spec_washable ~= nil then
		spec.fieldMultiplierOrig =  self.spec_washable.fieldMultiplier
	end
	local configFile = DirtyTireTracks.confDir .. "DirtyTireTracksConfig.xml"
	if fileExists(configFile) then
		self:loadFromXmlDirtyTireTracks(self:dttGetFullName())
	else
		createFolder(getUserProfileAppPath().. "modsSettings/")
		createFolder(DirtyTireTracks.confDir)
		DirtyTireTracks.configXml = createXMLFile("DirtyTireTracks_XML", configFile, "DirtyTireTracksConfig")
		self:saveToXmlDirtyTireTracks(self)
	end
	if g_currentMission.densityMapModifiers['updateDttGrassArea'] == nil then
        local dMM = {}
        dMM.modifier = DensityMapModifier:new(g_currentMission.terrainDetailId,0,3)
        dMM.filter = DensityMapFilter:new(dMM.modifier)
        dMM.mask = DensityMapFilter:new(g_currentMission.terrainDetailId,0,3)
        g_currentMission.densityMapModifiers['updateDttGrassArea'] = dMM
    end
end
function DirtyTireTracks:onPostLoad(savegame)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	if self.selectionObject.vehicle.isVehicleSaved then
		DirtyTireTracks.vehiclesCount = DirtyTireTracks.vehiclesCount + 1
		spec.vehicleId = DirtyTireTracks.vehiclesCount
		DirtyTireTracks.vehicles[spec.vehicleId] = self
	end
	if spec.event_IDs == nil then
		spec.event_IDs = {}
	end
	for _,wheel in pairs(self.spec_wheels.wheels) do
		wheel.supportsWheelSinkOrig = wheel.supportsWheelSink
		if wheel.additionalWheels ~= nil then
			for _,additionalWheel in pairs(wheel.additionalWheels) do
				additionalWheel.supportsWheelSinkOrig = additionalWheel.supportsWheelSink
			end
		end
	end
	if savegame ~= nil then
		local xmlFile = savegame.xmlFile
		local key = savegame.key ..".DirtyTireTracks"
		spec.vehicleId = Utils.getNoNil(getXMLInt(xmlFile, key.."#id"), spec.vehicleId)
		spec.fromSavegame = Utils.getNoNil(getXMLBool(xmlFile, key.."#fromSavegame"), spec.fromSavegame)
		if spec.vehicleId > DirtyTireTracks.vehiclesCount then
			DirtyTireTracks.vehiclesCount = spec.vehicleId
		end
    end
	if self.isServer then
		if g_currentMission.missionInfo.savegameIndex ~= nil and self.selectionObject.vehicle.isVehicleSaved then
			spec.tracksFile = {}
			local index = 1
			while true do
				local tracksFile = DirtyTireTracks.confDir .. 'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/' .. self:dttGetFullName()..'_'..spec.vehicleId..'/'..(index < 1000 and (index < 100 and (index < 10 and '000' or '00') or '0') or '')..tostring(index)..'.xml'
				if fileExists(tracksFile) then
					if g_currentMission.missionInfo.savegameDirectory ~= nil and spec.fromSavegame then
						spec.tracksFile[index] = loadXMLFile("Tracks_XML", tracksFile)
						self:loadTracksFromXML(spec.tracksFile[index], index)
						index = index + 1
					else
						createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/'..self:dttGetFullName()..'_'..spec.vehicleId..'/')
						spec.tracksFile[index] = createXMLFile("Tracks_XML", tracksFile, "Tracks")
						saveXMLFile(spec.tracksFile[index])
						index = index + 1
					end
				else
					if index == 1 then
						createFolder(getUserProfileAppPath().. "modsSettings/")
						createFolder(DirtyTireTracks.confDir)
						createFolder(DirtyTireTracks.confDir..'Tracks/')
						createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/')
						createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/'..self:dttGetFullName()..'_'..spec.vehicleId..'/')
						spec.tracksFile[index] = createXMLFile("Tracks_XML", tracksFile, "Tracks")
						saveXMLFile(spec.tracksFile[index])
						index = index + 1
					else
						break
					end
				end
			end
		end
	end
end
function DirtyTireTracks:saveToXMLFile(xmlFile, key)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	setXMLInt(xmlFile, key.."#id", spec.vehicleId)
	setXMLBool(xmlFile, key.."#fromSavegame", true)
end
function DirtyTireTracks:onPreDelete()
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	if self.selectionObject.vehicle.isVehicleSaved then
		if self.isServer then
			self:deleteTireTracksCurrent()
		end
		DirtyTireTracks.vehicles[spec.vehicleId] = nil
	end
end
function DirtyTireTracks:loadFromXmlDirtyTireTracks(vehicle)
	local spec = self.spec_dirtyTireTracks
	
	local configFile = DirtyTireTracks.confDir .. "DirtyTireTracksConfig.xml"
	if fileExists(configFile) then
		DirtyTireTracks.configXml = loadXMLFile("DirtyTireTracks_XML", configFile)
	end
	if fileExists(configFile) then
		if getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.showHelp") ~= nil then
			DirtyTireTracks.showHelp = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.showHelp")
		end
		if getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.modActiveGlobal") ~= nil then
			DirtyTireTracks.modActive = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.modActiveGlobal")
		end
		if getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.duration") ~= nil then
			DirtyTireTracks.duration = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.duration")
		end
		if getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.minWetFactor") ~= nil then
			DirtyTireTracks.minWetFactor = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.minWetFactor")
		end
		if getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.sizeFactor") ~= nil then
			DirtyTireTracks.sizeFactor = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.sizeFactor")
		end
		if getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.wetDepend") ~= nil then
			DirtyTireTracks.wetDepend = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.wetDepend")
		end
		if getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.activeOnField") ~= nil then
			DirtyTireTracks.activeOnField = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.activeOnField")
		end
		if getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.saveTracks") ~= nil then
			DirtyTireTracks.saveTracks = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.saveTracks")
		end
		if vehicle ~= nil then
			local key = "DirtyTireTracksConfig.dttActiveVehicles"
			local i = 0
			while true do
				local name = getXMLString(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#name")
				if name ~= nil then
					if name == vehicle then
						spec.modActive = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i))
						spec.currentConfig = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#currentConfig")
						spec.duration = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#duration")
						spec.wetDepend = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#wetDepend")
						spec.minWetFactor = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#minWetFactor")
						spec.sizeFactor = getXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#sizeFactor")
						spec.activeOnField = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#activeOnField")
						spec.saveTracks = getXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#saveTracks")
						
						spec.currentConfigIndex = getIndexFromElement(DirtyTireTracks.currentConfigs, spec.currentConfig)
						spec.durationIndex = getIndexFromElement(DirtyTireTracks.durations, spec.duration)
						spec.wetDependIndex = getIndexFromElement(DirtyTireTracks.wetDepends, spec.wetDepend)
						spec.minWetFactorIndex = getIndexFromElement(DirtyTireTracks.minWetFactors, spec.minWetFactor)
						spec.sizeFactorIndex = getIndexFromElement(DirtyTireTracks.sizeFactors, spec.sizeFactor)
						spec.activeOnFieldIndex = getIndexFromElement(DirtyTireTracks.activeOnFields, spec.activeOnField)
						spec.saveTracksIndex = getIndexFromElement(DirtyTireTracks.saveTrackss, spec.saveTracks)
						break
					end
				else
					break
				end
				i = i + 1
			end
		end
		DirtyTireTracks.durationIndex = getIndexFromElement(DirtyTireTracks.durations, DirtyTireTracks.duration)
		DirtyTireTracks.wetDependIndex = getIndexFromElement(DirtyTireTracks.wetDepends, DirtyTireTracks.wetDepend)
		DirtyTireTracks.minWetFactorIndex = getIndexFromElement(DirtyTireTracks.minWetFactors, DirtyTireTracks.minWetFactor)
		DirtyTireTracks.sizeFactorIndex = getIndexFromElement(DirtyTireTracks.sizeFactors, DirtyTireTracks.sizeFactor)
		DirtyTireTracks.activeOnFieldIndex = getIndexFromElement(DirtyTireTracks.activeOnFields, DirtyTireTracks.activeOnField)
		DirtyTireTracks.saveTracksIndex = getIndexFromElement(DirtyTireTracks.saveTrackss, DirtyTireTracks.saveTracks)
	end
end
function DirtyTireTracks:saveToXmlDirtyTireTracks(vehicleId, vehicle, active)
	local spec = vehicleId.spec_dirtyTireTracks
	
	--if self.isServer or g_currentMission.isMasterUser then
		if DirtyTireTracks.configXml ~= nil then
			setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.showHelp", DirtyTireTracks.showHelp)
			setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.modActiveGlobal", DirtyTireTracks.modActive)
			setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.duration", DirtyTireTracks.duration)
			setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.minWetFactor", DirtyTireTracks.minWetFactor)
			setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.sizeFactor", DirtyTireTracks.sizeFactor)
			setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.wetDepend", DirtyTireTracks.wetDepend)
			setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.activeOnField", DirtyTireTracks.activeOnField)
			setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.saveTracks", DirtyTireTracks.saveTracks)
			if vehicle ~= nil and active ~= nil then
				local key = "DirtyTireTracksConfig.dttActiveVehicles"
				local i = 0
				while true do
					local name = getXMLString(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#name")
					if name ~= nil then
						if name == vehicle then
							setXMLString(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#name", vehicle)
							setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#currentConfig", spec.currentConfig)
							setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#duration", spec.duration)
							setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#wetDepend", spec.wetDepend)
							setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#minWetFactor", spec.minWetFactor)
							setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#sizeFactor", spec.sizeFactor)
							setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#activeOnField", spec.activeOnField)
							setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#saveTracks", spec.saveTracks)
							setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i), active)
							break
						end
					else
						setXMLString(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#name", vehicle)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#currentConfig", spec.currentConfig)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#duration", spec.duration)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#wetDepend", spec.wetDepend)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#minWetFactor", spec.minWetFactor)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#sizeFactor", spec.sizeFactor)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#activeOnField", spec.activeOnField)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#saveTracks", spec.saveTracks)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i), active)
						break
					end
					i = i + 1
					local name = key .. string.format(".vehicle(%d)", i)
					if not hasXMLProperty(DirtyTireTracks.configXml, name) then
						setXMLString(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#name", vehicle)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#currentConfig", spec.currentConfig)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#duration", spec.duration)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#wetDepend", spec.wetDepend)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#minWetFactor", spec.minWetFactor)
						setXMLFloat(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#sizeFactor", spec.sizeFactor)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#activeOnField", spec.activeOnField)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i).."#saveTracks", spec.saveTracks)
						setXMLBool(DirtyTireTracks.configXml, "DirtyTireTracksConfig.dttActiveVehicles"..string.format(".vehicle(%d)", i), active)
						break
					end
				end
			end
			saveXMLFile(DirtyTireTracks.configXml)
		end
	--end
end
function DirtyTireTracks:saveTracksToXML(vehicle, day, time, x0, z0, x1, z1, x2, z2, grass, id)
	local spec = self.spec_dirtyTireTracks
	
	if g_currentMission.missionInfo.savegameIndex ~= nil then
		local tracksFile = DirtyTireTracks.confDir .. 'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/' .. self:dttGetFullName()..'_'..spec.vehicleId..'/'..(spec.indexSave < 1000 and (spec.indexSave < 100 and (spec.indexSave < 10 and '000' or '00') or '0') or '')..tostring(spec.indexSave)..'.xml'
		
		if not fileExists(tracksFile) then
			createFolder(getUserProfileAppPath().. "modsSettings/")
			createFolder(DirtyTireTracks.confDir)
			createFolder(DirtyTireTracks.confDir..'Tracks/')
			createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/')
			createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/'..self:dttGetFullName()..'_'..spec.vehicleId..'/')
			spec.tracksFile[spec.indexSave] = createXMLFile("Tracks_XML", tracksFile, "Tracks")
			saveXMLFile(spec.tracksFile[spec.indexSave])
		end
		local file = spec.tracksFile[spec.indexSave]
		if id ~= nil then setXMLInt(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#i", id) end
		setXMLInt(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#d", day)
		setXMLInt(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#t", time)
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#x0", floatToString(x0))
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#z0", floatToString(z0))
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#x1", floatToString(x1))
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#z1", floatToString(z1))
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#x2", floatToString(x2))
		setXMLString(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#z2", floatToString(z2))
		setXMLInt(file, "Tracks.tracks"..string.format(".t(%d)", spec.trackToSaveIndex).."#g", grass and 1 or 0)
		spec.trackToSaveIndex = spec.trackToSaveIndex + 1
	end
end
function DirtyTireTracks:loadTracksFromXML(xmlFile, index)
	local spec = self.spec_dirtyTireTracks
	
    local k = 0
	local tracks = {}
	local key = "Tracks.tracks"
    if not hasXMLProperty(xmlFile, key) then
        return
    end
	table.insert(spec.tireTracks, tracks)
    while true do
        local key = "Tracks.tracks"..string.format(".t(%d)", k)
        if not hasXMLProperty(xmlFile, key) then
            break
        end
		local tracks = {}
		tracks.id = getXMLInt(xmlFile, key.."#i")
		tracks.day = getXMLInt(xmlFile, key.."#d")
        tracks.time = getXMLInt(xmlFile, key.."#t")
        tracks.x0 = stringToFloat(getXMLString(xmlFile, key.."#x0"))
        tracks.z0 = stringToFloat(getXMLString(xmlFile, key.."#z0"))
        tracks.x1 = stringToFloat(getXMLString(xmlFile, key.."#x1"))
        tracks.z1 = stringToFloat(getXMLString(xmlFile, key.."#z1"))
        tracks.x2 = stringToFloat(getXMLString(xmlFile, key.."#x2"))
        tracks.z2 = stringToFloat(getXMLString(xmlFile, key.."#z2"))
        tracks.grass = getXMLInt(xmlFile, key.."#g") == 1 and true or false
        tracks.saved = true
        tracks.erased = false
		if tracks.time ~= nil and tracks.x0 ~= nil and tracks.z0 ~= nil and tracks.x1 ~= nil and tracks.z1 ~= nil and tracks.x2 ~= nil and tracks.z2 ~= nil and tracks.grass ~= nil and tracks.id ~= nil then
            table.insert(spec.tireTracks[index], tracks)
			spec.trackId = tracks.id + 1
        end
        k = k + 1
    end
	spec.index = index
	spec.indexSave = index
	spec.trackToSaveIndex = k
end
function DirtyTireTracks:createTracksFile(index)
	local spec = self.spec_dirtyTireTracks
		
	local tracksFile = DirtyTireTracks.confDir .. 'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/' .. self:dttGetFullName()..'_'..spec.vehicleId..'/'..(index < 1000 and (index < 100 and (index < 10 and '000' or '00') or '0') or '')..tostring(index)..'.xml'
	createFolder(getUserProfileAppPath().. "modsSettings/")
	createFolder(DirtyTireTracks.confDir)
	createFolder(DirtyTireTracks.confDir..'Tracks/')
	createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/')
	createFolder(DirtyTireTracks.confDir..'Tracks/'..g_currentMission.missionInfo.savegameIndex..'/'..self:dttGetFullName()..'_'..spec.vehicleId..'/')
	spec.tracksFile[index] = createXMLFile("Tracks_XML", tracksFile, "Tracks")
	saveXMLFile(spec.tracksFile[index])
end
function DirtyTireTracks:deleteTireTracks(eraseOnly, noEventSend)
	if self.isServer or g_currentMission.isMasterUser then
		if not DirtyTireTracks.deletedOnSaveGame then
			DirtyTireTracks.deletedOnSaveGame = true
			for i,vehicle in pairs(DirtyTireTracks.vehicles) do
				if vehicle ~= nil and vehicle.spec_dirtyTireTracks ~= nil then
					spec = vehicle.spec_dirtyTireTracks
					for i,tracks in pairs(spec.tireTracks) do
						if table.getn(tracks) ~= 0 then
							local fileUpdated = false
							for j,track in pairs(tracks) do
								if not track.saved or not eraseOnly then
									FSDensityMapUtil.removeFieldArea(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2)
								end
								if track.grass and not eraseOnly then
									local ids = g_currentMission.fruits[g_fruitTypeManager.nameToIndex['GRASS']]
									if ids == nil or ids.id == 0 then
										return 0
									end
									local mapModifier = g_currentMission.densityMapModifiers.updateDttGrassArea.modifier
									local mapFilter = g_currentMission.densityMapModifiers.updateDttGrassArea.filter
									local mapMask = g_currentMission.densityMapModifiers.updateDttGrassArea.mask
									mapModifier:setParallelogramWorldCoords(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2, 'ppp')
									mapModifier:resetDensityMapAndChannels(ids.id,0,4)
									mapFilter:resetDensityMapAndChannels(ids.id,0,4)
									mapMask:setValueCompareParams('equal', 0)
									mapFilter:setValueCompareParams('equal', 0)
									local areaValue, modArea, area = mapModifier:executeSet(5,mapMask,mapFilter)
								end
								if track.saved and not eraseOnly then
									removeXMLProperty(spec.tracksFile[i], "Tracks.tracks"..string.format(".t(%d)", 0))
									fileUpdated = true
								end						
							end
							if not eraseOnly then
								spec.tireTracks[i] = {}
								if fileUpdated then
									saveXMLFile(spec.tracksFile[i])
								end
							end
						end
					end
					if not eraseOnly then
						spec.index = 1
						spec.index2 = 1
						spec.trackId = 1
						spec.trackToSaveIndex = 0
						spec.indexSave = 1
					end
				end
			end
		end
	end
	DirtyTireTracksDeleteTracksEvent.sendEvent(self, false, noEventSend)
end
function DirtyTireTracks:deleteTireTracksCurrent(noEventSend)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	if self.isServer then
		for i,tracks in pairs(spec.tireTracks) do
			if table.getn(tracks) ~= 0 then
				local fileUpdated = false
				for j,track in pairs(tracks) do
					FSDensityMapUtil.removeFieldArea(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2)
					if track.grass then
						local ids = g_currentMission.fruits[g_fruitTypeManager.nameToIndex['GRASS']]
						if ids == nil or ids.id == 0 then
							return 0
						end
						local mapModifier = g_currentMission.densityMapModifiers.updateDttGrassArea.modifier
						local mapFilter = g_currentMission.densityMapModifiers.updateDttGrassArea.filter
						local mapMask = g_currentMission.densityMapModifiers.updateDttGrassArea.mask
						mapModifier:setParallelogramWorldCoords(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2, 'ppp')
						mapModifier:resetDensityMapAndChannels(ids.id,0,4)
						mapFilter:resetDensityMapAndChannels(ids.id,0,4)
						mapMask:setValueCompareParams('equal', 0)
						mapFilter:setValueCompareParams('equal', 0)
						local areaValue, modArea, area = mapModifier:executeSet(5,mapMask,mapFilter)
					end
					if track.saved then
						removeXMLProperty(spec.tracksFile[i], "Tracks.tracks"..string.format(".t(%d)", 0))
						fileUpdated = true
					end
					
				end
				spec.tireTracks[i] = {}
				if fileUpdated then
					saveXMLFile(spec.tracksFile[i])
				end
			end
		end
		spec.index = 1
		spec.index2 = 1
		spec.trackId = 1
		spec.trackToSaveIndex = 0
		spec.indexSave = 1
	end
	DirtyTireTracksDeleteTracksEvent.sendEvent(self, true, noEventSend)
end
function DirtyTireTracks:restoreTireTracks()
	if self.isServer or g_currentMission.isMasterUser then
		if not DirtyTireTracks.restoredOnSaveGame then
			DirtyTireTracks.restoredOnSaveGame = true
			for i,vehicle in pairs(DirtyTireTracks.vehicles) do
				if vehicle ~= nil and vehicle.spec_dirtyTireTracks ~= nil then
					spec = vehicle.spec_dirtyTireTracks
					for i,tracks in pairs(spec.tireTracks) do
						if table.getn(tracks) ~= 0 then
							for j,track in pairs(tracks) do
								if not track.erased and not track.saved then
									realArea, area = FSDensityMapUtil.updateCultivatorArea(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2, true, true, nil, nil)-------------------ZKUSIT BEZ AREAS KVULI ZRYCHLENI
								end
							end
						end
					end
				end
			end
		end
	end
end
function DirtyTireTracks:groundRaycastCallbackNew(hitObjectId, x, y, z, distance)
    local spec = self.spec_dirtyTireTracks
	
    spec.groundRaycastResult.y = y
    spec.groundRaycastResult.object = hitObjectId
    spec.groundRaycastResult.distance = distance
    return false
end
function DirtyTireTracks:onUpdate(dt)
	local spec = self.spec_dirtyTireTracks
	
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	if DirtyTireTracks.deletedOnSaveGame == true then
		DirtyTireTracks.deletedOnSaveGame = false
	end
	if DirtyTireTracks.restoredOnSaveGame == true then
		DirtyTireTracks.restoredOnSaveGame = false
	end
	
	local duration, minWetFactor, sizeFactor, wetDepend, activeOnField, saveTracks
	if spec.currentConfig then
		duration = spec.duration
		minWetFactor = spec.minWetFactor
		sizeFactor = spec.sizeFactor
		wetDepend = spec.wetDepend
		activeOnField = spec.activeOnField
		saveTracks = DirtyTireTracks.saveTracks
	else
		duration = DirtyTireTracks.duration
		minWetFactor = DirtyTireTracks.minWetFactor
		sizeFactor = DirtyTireTracks.sizeFactor
		wetDepend = DirtyTireTracks.wetDepend
		activeOnField = DirtyTireTracks.activeOnField
		saveTracks = DirtyTireTracks.saveTracks
	end
	--spec.infoText = ''
	if self.isServer then
		local x,_,z = getWorldTranslation(self.rootNode)
		local diff = MathUtil.vector2Length(x-spec.lastWorldX, z-spec.lastWorldZ)
		local kon = 0.5
		if diff > kon then
			spec.lastWorldX, _, spec.lastWorldZ = getWorldTranslation(self.rootNode)
			if self:getIsActive() and spec.modActive and DirtyTireTracks.modActive and self:getLastSpeed() > 0.1 then
				local anyActive = false
				for i,wheel in pairs(self.spec_wheels.wheels) do
					if wheel.hasTireTracks or wheel.hasParticles then
						groundWetness = g_currentMission.environment.weather:getGroundWetness()
						local width = 0.5 * wheel.width * sizeFactor
						if wetDepend then
							width = width * groundWetness
						end
						spec.width = width
						local length = math.min(0.2, 0.2 * wheel.width)
						local x, _, z = localToLocal(wheel.driveNode, wheel.repr, 0, 0, 0)
						local x0, y0, z0 = localToWorld(wheel.repr, x + width, 0, z - length)
						local x1, y1, z1 = localToWorld(wheel.repr, x - width, 0, z - length)
						local x2, y2, z2 = localToWorld(wheel.repr, x + width, 0, z + length)
						spec.groundRaycastResult.object = 0
						spec.groundRaycastResult.y = y0 - 1
						raycastClosest(x0, y0, z0, 0.0, -1.0, 0.0, "groundRaycastCallbackNew", 5, self, 59)
						local hitTerrain = spec.groundRaycastResult.object == g_currentMission.terrainRootNode
						local x3, y3, z3
						if self.movingDirection > 0 then
							x3, y3, z3 = x2, y2, z2
						else
							x3, y3, z3 = x0, y0, z0
						end
						local _, _, _, a , materialId = getTerrainAttributesAtWorldPos(g_currentMission.terrainRootNode, x3, y3, z3, true, true, true, true, false)
						local onField = false
						local densityBits = 0
						local bits = getDensityAtWorldPos(g_currentMission.terrainDetailId, x3, y3, z3)
						densityBits = bitOR(densityBits, bits)
						if densityBits ~= 0 then
							onField = true
						end
						if a ~= 0 and hitTerrain and groundWetness >= minWetFactor and (not onField or activeOnField) and (not self:getIsAIActive() or onField) then
							local track = {}
							local ids = g_currentMission.fruits[g_fruitTypeManager.nameToIndex['GRASS']]
							if ids == nil or ids.id == 0 then
								return 0
							end
							local mapModifier = g_currentMission.densityMapModifiers.updateDttGrassArea.modifier
							local mapFilter = g_currentMission.densityMapModifiers.updateDttGrassArea.filter
							local mapMask = g_currentMission.densityMapModifiers.updateDttGrassArea.mask
							mapModifier:setParallelogramWorldCoords(x0, z0, x1, z1, x2, z2, 'ppp')
							mapModifier:resetDensityMapAndChannels(ids.id,0,4)
							mapFilter:resetDensityMapAndChannels(ids.id,0,4)
							mapMask:setValueCompareParams('equal', 0)
							mapFilter:setValueCompareParams('equal', 0)
							local areaValue, modArea, area = mapModifier:executeSet(1,mapMask,mapFilter)
							if modArea ~= 0 then
								track.grass = false
								--spec.infoText = spec.infoText .. 'grass modArea - '..string.format("%.0f",modArea)..'\n'
							else
								track.grass = true
								--spec.infoText = spec.infoText .. 'grass modArea - not\n'
							end
							local realArea, area = FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
							if realArea ~= nil and realArea ~= 0 then
								anyActive = true
								if spec.tireTracks[spec.index] == nil then
									spec.tireTracks[spec.index] = {}
								end
								if spec.trackId > spec.tracksToTable then
									spec.index = spec.index + 1
									spec.tireTracks[spec.index] = {}
									spec.trackId = 1
								end
								track.x0 = x0
								track.z0 = z0
								track.x1 = x1
								track.z1 = z1
								track.x2 = x2
								track.z2 = z2
								track.day = g_currentMission.hud.environment.currentDay
								track.time = g_currentMission.environment.dayTime / 1000
								track.saved = false
								track.toSave = saveTracks
								track.id = spec.trackId
								track.erased = false
								table.insert(spec.tireTracks[spec.index], track)
								spec.trackId = spec.trackId + 1
								--spec.infoText = spec.infoText .. 'realArea - '..string.format("%.0f",realArea)..'\n'
								--spec.infoText = spec.infoText .. 'area - '..string.format("%.0f",area)..'\n'
							else
								--spec.infoText = spec.infoText .. 'realArea - not\n'
								--spec.infoText = spec.infoText .. 'area - not\n'
							end
						else
							--spec.infoText = spec.infoText .. 'realArea - not\n'
							--spec.infoText = spec.infoText .. 'area - not\n'
							--spec.infoText = spec.infoText .. 'grass modArea - not\n'
						end
					end
					if wheel.additionalWheels ~= nil then
						for _,additionalWheel in pairs(wheel.additionalWheels) do
							if additionalWheel.hasTireTracks or additionalWheel.hasParticles then
								groundWetness = g_currentMission.environment.weather:getGroundWetness()
								local width = 0.5 * additionalWheel.width * sizeFactor
								if wetDepend then
									width = width * groundWetness
								end
								spec.width = width
								local length = math.min(0.2, 0.2 * additionalWheel.width)
								local refNode = wheel.node
								if wheel.repr ~= wheel.driveNode then
									refNode = wheel.repr
								end
								local xShift, yShift, zShift = localToLocal(additionalWheel.wheelTire, refNode, 0, 0, 0)
								local x0, y0, z0 = localToWorld(refNode, xShift + width, yShift, zShift - length)
								local x1, y1, z1 = localToWorld(refNode, xShift - width, yShift, zShift - length)
								local x2, y2, z2 = localToWorld(refNode, xShift + width, yShift, zShift + length)
								spec.groundRaycastResult.object = 0
								spec.groundRaycastResult.y = y0 - 1
								raycastClosest(x0, y0, z0, 0.0, -1.0, 0.0, "groundRaycastCallbackNew", 5, self, 59)
								local hitTerrain = spec.groundRaycastResult.object == g_currentMission.terrainRootNode
								local x3, y3, z3
								if self.movingDirection > 0 then
									x3, y3, z3 = x2, y2, z2
								else
									x3, y3, z3 = x0, y0, z0
								end
								local _, _, _, a , materialId = getTerrainAttributesAtWorldPos(g_currentMission.terrainRootNode, x3, y3, z3, true, true, true, true, false)
								local onField = false
								local densityBits = 0
								local bits = getDensityAtWorldPos(g_currentMission.terrainDetailId, x3, y3, z3)
								densityBits = bitOR(densityBits, bits)
								if densityBits ~= 0 then
									onField = true
								end
								if a ~= 0 and hitTerrain and groundWetness >= minWetFactor and (not onField or activeOnField) and (not self:getIsAIActive() or onField) then
									local track = {}
									local ids = g_currentMission.fruits[g_fruitTypeManager.nameToIndex['GRASS']]
									if ids == nil or ids.id == 0 then
										return 0
									end
									local mapModifier = g_currentMission.densityMapModifiers.updateDttGrassArea.modifier
									local mapFilter = g_currentMission.densityMapModifiers.updateDttGrassArea.filter
									local mapMask = g_currentMission.densityMapModifiers.updateDttGrassArea.mask
									mapModifier:setParallelogramWorldCoords(x0, z0, x1, z1, x2, z2, 'ppp')
									mapModifier:resetDensityMapAndChannels(ids.id,0,4)
									mapFilter:resetDensityMapAndChannels(ids.id,0,4)
									mapMask:setValueCompareParams('equal', 0)
									mapFilter:setValueCompareParams('equal', 0)
									local areaValue, modArea, area = mapModifier:executeSet(1,mapMask,mapFilter)
									if modArea ~= 0 then
										track.grass = false
										--spec.infoText = spec.infoText .. 'grass modArea - '..string.format("%.0f",modArea)..'\n'
									else
										track.grass = true
										--spec.infoText = spec.infoText .. 'grass modArea - not\n'
									end
									local realArea, area = FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
									if realArea ~= nil and realArea ~= 0 then
										anyActive = true
										if spec.tireTracks[spec.index] == nil then
											spec.tireTracks[spec.index] = {}
										end
										if spec.trackId > spec.tracksToTable then
											spec.index = spec.index + 1
											spec.tireTracks[spec.index] = {}
											spec.trackId = 1
										end
										track.x0 = x0
										track.z0 = z0
										track.x1 = x1
										track.z1 = z1
										track.x2 = x2
										track.z2 = z2
										track.day = g_currentMission.hud.environment.currentDay
										track.time = g_currentMission.environment.dayTime / 1000
										track.saved = false
										track.toSave = saveTracks
										track.id = spec.trackId
										track.erased = false
										table.insert(spec.tireTracks[spec.index], track)
										spec.trackId = spec.trackId + 1
										--spec.infoText = spec.infoText .. 'realArea - '..string.format("%.0f",realArea)..'\n'
										--spec.infoText = spec.infoText .. 'area - '..string.format("%.0f",area)..'\n'
									else
										--spec.infoText = spec.infoText .. 'realArea - not\n'
										--spec.infoText = spec.infoText .. 'area - not\n'
									end
								else
									--spec.infoText = spec.infoText .. 'realArea - not\n'
									--spec.infoText = spec.infoText .. 'area - not\n'
								end
							end
						end
					end
				end
				if spec.timer <= 2000 then
					spec.timer = spec.timer + dt
				end
				if anyActive then
					spec.timer = 0
				end
				--spec.infoText = spec.infoText .. 'timer - '..string.format("%.3f",spec.timer)..'\n'
				for i,wheel in pairs(self.spec_wheels.wheels) do
					if spec.timer >= 1000 and spec.timer < 2000 then
						wheel.supportsWheelSink = wheel.supportsWheelSinkOrig
						if wheel.additionalWheels ~= nil then
							for _,additionalWheel in pairs(wheel.additionalWheels) do
								additionalWheel.supportsWheelSink = additionalWheel.supportsWheelSinkOrig
								--spec.infoText = spec.infoText .. i..'add supportsWheelSink - '..tostring(additionalWheel.supportsWheelSink)..'\n'
							end
						end
						if self.spec_washable ~= nil then
							self.spec_washable.fieldMultiplier = spec.fieldMultiplierOrig
						end
					elseif spec.timer == 0 then
						wheel.supportsWheelSink = false
						if wheel.additionalWheels ~= nil then
							for _,additionalWheel in pairs(wheel.additionalWheels) do
								additionalWheel.supportsWheelSink = false
								--spec.infoText = spec.infoText .. i..'add supportsWheelSink - '..tostring(additionalWheel.supportsWheelSink)..'\n'
							end
						end
						if self.spec_washable ~= nil then
							self.spec_washable.fieldMultiplier = 0.1
						end
					end
					--spec.infoText = spec.infoText .. i..' supportsWheelSink - '..tostring(wheel.supportsWheelSink)..'\n'
				end
			end
		else
			--spec.infoText = spec.infoText .. 'realArea - not\n'
			--spec.infoText = spec.infoText .. 'area - not\n'
		end
	end
	
	--[[if self.getIsControlled ~= nil and self:getIsControlled() then
		spec.infoText = spec.infoText .. "fieldMultiplier: " .. string.format("%.3f",self.spec_washable.fieldMultiplier).."\n"
		if self.spec_washable ~= nil then
			for index,dirt in pairs(self.spec_washable.washableNodes) do
				spec.infoText = spec.infoText .. "dirty: " .. string.format("%.5f",self.spec_washable.washableNodes[index].dirtAmount).."\n"
			end
		end
		spec.infoText = spec.infoText .. ' hasDtt - '..tostring(self:getHasDttImplement())..'\n'
		spec.infoText = spec.infoText .. ' modActive - '..tostring(spec.modActive)..'\n'
		spec.infoText = spec.infoText .. ' modActiveGlobal - '..tostring(DirtyTireTracks.modActive)..'\n'
		spec.infoText = spec.infoText .. ' index - '..spec.index..'\n'
		if spec.tireTracks[spec.index] ~= nil then spec.infoText = spec.infoText .. ' count - '..table.getn(spec.tireTracks[spec.index])..'\n' end
		spec.infoText = spec.infoText .. ' indexErase - '..spec.index2..'\n'
		if spec.tireTracks[spec.index2] ~= nil then spec.infoText = spec.infoText .. ' count - '..table.getn(spec.tireTracks[spec.index2])..'\n' end
		spec.infoText = spec.infoText .. ' indexSave - '..spec.indexSave..'\n'
		if spec.tireTracks[spec.index2] ~= nil then
			for i,track in pairs(spec.tireTracks[spec.index2]) do
				if not track.erased then
					local currentDay = g_currentMission.hud.environment.currentDay
					local timeMax
					if track.day ~= currentDay then
						timeMax = (g_currentMission.environment.dayTime / 1000 + (86400 * (currentDay - 1))) - (track.time + (86400 * (track.day - 1)))
					else
						timeMax = (g_currentMission.environment.dayTime / 1000 + (86400 * (currentDay - 1))) - (track.time + (86400 * (track.day - 1)))
					end
					spec.infoText = spec.infoText .. ' time max - '..string.format("%.2f", timeMax / 60 / 60)..'\n'
					break
				end
			end
		end
		spec.infoText = spec.infoText .. ' dayTime - '.. string.format("%.0f", g_currentMission.environment.dayTime / 1000)..'\n'
		spec.infoText = spec.infoText .. ' currentDay - '.. g_currentMission.hud.environment.currentDay..'\n'
		local groundWetness = g_currentMission.environment.weather:getGroundWetness()
		spec.infoText = spec.infoText .. ' groundWetness - '..groundWetness..'\n'
		spec.infoText = spec.infoText .. ' spec.width - '..spec.width..'\n'
		spec.infoText = spec.infoText .. ' glob duration - '..DirtyTireTracks.duration..' ['..DirtyTireTracks.durationIndex..']\n'
		spec.infoText = spec.infoText .. ' spec duration - '..spec.duration..' ['..spec.durationIndex..']\n'
		spec.infoText = spec.infoText .. ' duration - '..duration..' ['..spec.durationIndex..']\n'
		spec.infoText = spec.infoText .. ' currentConfig - '..tostring(spec.currentConfig)..'\n'
		spec.infoText = spec.infoText .. ' spec.trackId - '..spec.trackId..'\n'
		spec.infoText = spec.infoText .. ' spec.trackToSaveIndex - '..spec.trackToSaveIndex..'\n'
		spec.infoText = spec.infoText .. ' spec.vehicleId - '..spec.vehicleId..'\n'
		spec.infoText = spec.infoText .. ' vehicles count - '..table.getn(DirtyTireTracks.vehicles)..'\n'
		spec.infoText = spec.infoText .. ' vehiclesCount - '..DirtyTireTracks.vehiclesCount..'\n'
		spec.infoText = spec.infoText .. ' getIsOnField() - '..tostring(self:getIsOnField())..'\n'
		renderText(0.7, 0.97, 0.015, spec.infoText)
		renderText(0.85, 0.85, 0.015, spec.infoText2)
		renderText(0.85, 0.75, 0.015, spec.infoText3)
		if true then
			if Input.isKeyPressed(Input.KEY_i) then
				spec.groundWetness = spec.groundWetness + 0.01
				if spec.groundWetness > 1 then
					spec.groundWetness = 1
				end
			elseif Input.isKeyPressed(Input.KEY_j) then
				spec.groundWetness = spec.groundWetness - 0.01
				if spec.groundWetness < 0 then
					spec.groundWetness = 0
				end
			end
		end
	end]]
	if self.isClient then
		if self:getIsActive() and (self:getIsActiveForInput() or not self:getHasDttImplement()) and (not self:getIsAIActive() or (self.getIsControlled ~= nil and self:getIsControlled())) then
			if spec.event_IDs ~= nil and g_dedicatedServerInfo == nil then
				for actionName,eventID in pairs(spec.event_IDs) do
					if actionName == InputAction.DIRTYTIRETRACK_ACTIVATE then
						g_inputBinding:setActionEventActive(eventID, g_currentMission.isMasterUser)
						g_inputBinding:setActionEventText(eventID, spec.modActive and g_i18n:getText('DIRTYTIRETRACK_DEACTIVATE') or g_i18n:getText('DIRTYTIRETRACK_ACTIVATE'))
					end
					if actionName == InputAction.DIRTYTIRETRACK_ACTIVATE_ALL then
						g_inputBinding:setActionEventActive(eventID, g_currentMission.isMasterUser)
						g_inputBinding:setActionEventText(eventID, DirtyTireTracks.modActive and g_i18n:getText('DIRTYTIRETRACK_DEACTIVATE_ALL') or g_i18n:getText('DIRTYTIRETRACK_ACTIVATE_ALL'))
					end
					if actionName == InputAction.DIRTYTIRETRACK_OPEN_MENU then
						g_inputBinding:setActionEventActive(eventID, g_currentMission.isMasterUser)
					end
				end
			end
		end
	end
end
function DirtyTireTracks:onUpdateTick(dt)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	local duration
	if spec.currentConfig then
		duration = spec.duration
	else
		duration = DirtyTireTracks.duration
	end
	
	if self.isServer then
		if spec.tireTracks[spec.index] ~= nil and table.getn(spec.tireTracks[spec.index]) > 20 then
			self:raiseActive()
		end
		if spec.modActive and DirtyTireTracks.modActive then
			spec.timerErase = spec.timerErase + dt
			spec.timerSave = spec.timerSave + dt
			if spec.timerSave >= 500 then
				--spec.infoText2 = ''
				local updated = false
				local count = 0
				if spec.tireTracks[spec.indexSave] ~= nil and DirtyTireTracks.saveTracks then
					local trackId = 0
					for i,track in pairs(spec.tireTracks[spec.indexSave]) do
						if not track.saved and track.toSave then
							self:saveTracksToXML(self:dttGetFullName(), track.day, track.time, track.x0, track.z0, track.x1, track.z1, track.x2, track.z2, track.grass, track.id)
							track.saved = true
							updated = true
							count = count + 1
						end
						trackId = track.id
					end
					if updated then
						saveXMLFile(spec.tracksFile[spec.indexSave])
					end
					if trackId == spec.tracksToTable then
						spec.indexSave = spec.indexSave + 1
						spec.trackToSaveIndex = 0
						self:createTracksFile(spec.indexSave)
					end
				end
				spec.timerSave = 0
				--spec.infoText2 = spec.infoText2 .. ' count saved - '..count..'\n'
			end
			if spec.timerErase >= 600 then
				--spec.infoText3 = ''
				local updated = false
				local count = 0
				if duration ~= 0 then
					for i,tracks in pairs(spec.tireTracks) do
						if table.getn(tracks) ~= 0 then
							spec.index2 = i
							local idUpdated
							local switchToNext = false
							for j,track in pairs(tracks) do
								local currentDay = g_currentMission.hud.environment.currentDay
								local trackTtime = track.time + (86400 * (track.day - 1))
								local diffTime = (g_currentMission.environment.dayTime / 1000 + (86400 * (currentDay - 1))) - trackTtime
								if (g_currentMission.environment.dayTime / 1000 + (86400 * (currentDay - 1))) - trackTtime >= duration * 60 * 60  and not track.erased then
									FSDensityMapUtil.removeFieldArea(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2)
									if track.grass then
										local ids = g_currentMission.fruits[g_fruitTypeManager.nameToIndex['GRASS']]
										if ids == nil or ids.id == 0 then
											return 0
										end
										local mapModifier = g_currentMission.densityMapModifiers.updateDttGrassArea.modifier
										local mapFilter = g_currentMission.densityMapModifiers.updateDttGrassArea.filter
										local mapMask = g_currentMission.densityMapModifiers.updateDttGrassArea.mask
										mapModifier:setParallelogramWorldCoords(track.x0, track.z0, track.x1, track.z1, track.x2, track.z2, 'ppp')
										mapModifier:resetDensityMapAndChannels(ids.id,0,4)
										mapFilter:resetDensityMapAndChannels(ids.id,0,4)
										mapMask:setValueCompareParams('equal', 0)
										mapFilter:setValueCompareParams('equal', 0)
										local areaValue, modArea, area = mapModifier:executeSet(5,mapMask,mapFilter)
									end
									if track.saved then
										removeXMLProperty(spec.tracksFile[spec.index2], "Tracks.tracks"..string.format(".t(%d)", 0))
										updated = true
										count = count + 1
									end
									idUpdated = track.id
									track.erased = true
									if j + 1 > table.getn(tracks) then
										switchToNext = true
									end
								end
							end
							if idUpdated == spec.tracksToTable or switchToNext then
								spec.tireTracks[i] = {}
							end
							--spec.infoText2 = spec.infoText2 .. ' indexErase - '..i..'\n'
							break
						end
					end
					if updated then
						saveXMLFile(spec.tracksFile[spec.index2])
						if spec.indexSave == spec.index2 then
							spec.trackToSaveIndex = spec.trackToSaveIndex - count
						end
					end
				end
				spec.timerErase = 0
				--spec.infoText3 = spec.infoText3 .. ' count removed - '..count..'\n'
			end
		end
	end
end
function DirtyTireTracks:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	if keyStatus > 0 then
		if actionName == 'DIRTYTIRETRACK_ACTIVATE' then
			if g_currentMission.isMasterUser then
				if DirtyTireTracks.modActive == false then
					g_currentMission:showBlinkingWarning(g_i18n:getText('DIRTYTIRETRACK_FIRST_ACTIVATE'))
				else
					self:activateDttMod(not spec.modActive, 'THIS')
				end
			end
		elseif actionName == 'DIRTYTIRETRACK_ACTIVATE_ALL' then
			if g_currentMission.isMasterUser then
				self:activateDttMod(not DirtyTireTracks.modActive, 'ALL')
			end
		elseif actionName == 'DIRTYTIRETRACK_OPEN_MENU' then
			if g_currentMission.isMasterUser then
				if DirtyTireTracks.gui.dtrSettingGui.isOpen then
					DirtyTireTracks.gui.dtrSettingGui:onClickBack()
				elseif g_gui.currentGui == nil then
					DirtyTireTracks.gui.dtrSettingGui:setTarget(self)
					DirtyTireTracks.gui.dtrSettingGui:setDuration(DirtyTireTracks.durationIndex)
					DirtyTireTracks.gui.dtrSettingGui:setWetDepend(DirtyTireTracks.wetDependIndex)
					DirtyTireTracks.gui.dtrSettingGui:setMinWetFactor(DirtyTireTracks.minWetFactorIndex)
					DirtyTireTracks.gui.dtrSettingGui:setSizeFactor(DirtyTireTracks.sizeFactorIndex)
					DirtyTireTracks.gui.dtrSettingGui:setActiveOnField(DirtyTireTracks.activeOnFieldIndex)
					DirtyTireTracks.gui.dtrSettingGui:setSaveTracks(DirtyTireTracks.saveTracksIndex)
					
					DirtyTireTracks.gui.dtrSettingGui:setCurrentConfig(spec.currentConfigIndex)
					
					DirtyTireTracks.gui.dtrSettingGui:setDurationCurrent(spec.durationIndex)
					DirtyTireTracks.gui.dtrSettingGui:setWetDependCurrent(spec.wetDependIndex)
					DirtyTireTracks.gui.dtrSettingGui:setMinWetFactorCurrent(spec.minWetFactorIndex)
					DirtyTireTracks.gui.dtrSettingGui:setSizeFactorCurrent(spec.sizeFactorIndex)
					DirtyTireTracks.gui.dtrSettingGui:setActiveOnFieldCurrent(spec.activeOnFieldIndex)
					
					DirtyTireTracks.gui.dtrSettingGui.durationCurrent:setDisabled(not spec.currentConfig)
					DirtyTireTracks.gui.dtrSettingGui.wetDependCurrent:setDisabled(not spec.currentConfig)
					DirtyTireTracks.gui.dtrSettingGui.minWetFactorCurrent:setDisabled(not spec.currentConfig)
					DirtyTireTracks.gui.dtrSettingGui.sizeFactorCurrent:setDisabled(not spec.currentConfig)
					DirtyTireTracks.gui.dtrSettingGui.activeOnFieldCurrent:setDisabled(not spec.currentConfig)
					g_gui:showGui("dtrGui")
				end
			end
		end
	end
end
function DirtyTireTracks:activateDttMod(status, mode)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	if mode == 'THIS' then
		mode = self:dttGetFullName()
	end
	local text = 'ACTIVATED'
	if not status then
		text = 'DEACTIVATED'
	end
	local blink = ''
	if text == 'ACTIVATED' then
		blink = g_i18n:getText('DIRTYTIRETRACK_ACTIVATED')
	else
		blink = g_i18n:getText('DIRTYTIRETRACK_DEACTIVATED')
	end
	blink = blink .. ' '
	if mode == 'ALL' then
		blink = blink .. g_i18n:getText('DIRTYTIRETRACK_ALL_VEHICLES')
	else
		blink = blink .. tostring(mode)
	end
	g_currentMission:showBlinkingWarning(blink, 2000)
	if mode == 'ALL' then
		self:toggleActiveDirtyTireTracks(spec.modActive, status, false)
	else
		self:toggleActiveDirtyTireTracks(status, DirtyTireTracks.modActive, false)
	end
end
function DirtyTireTracks:toggleActiveDirtyTireTracks(modActive, modActiveGlobal, noEventSend)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	if spec.modActive ~= modActive then
		spec.modActive = modActive
		self:saveToXmlDirtyTireTracks(self, self:dttGetFullName(), modActive)
	elseif DirtyTireTracks.modActive ~= modActiveGlobal then
		DirtyTireTracks.modActive = modActiveGlobal
		self:saveToXmlDirtyTireTracks(self)
	end
	spec.modActive = modActive
	DirtyTireTracks.modActive = modActiveGlobal
	
	DirtyTireTracksToggleActiveEvent.sendEvent(self, modActive, modActiveGlobal, noEventSend)
end
function DirtyTireTracks:setGlobalConfig(duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	DirtyTireTracks.duration =  duration
	DirtyTireTracks.wetDepend = wetDepend
	DirtyTireTracks.minWetFactor = minWetFactor
	DirtyTireTracks.sizeFactor = sizeFactor
	DirtyTireTracks.activeOnField = activeOnField
	DirtyTireTracks.saveTracks = saveTracks
	
	DirtyTireTracks.durationIndex = getIndexFromElement(DirtyTireTracks.durations, DirtyTireTracks.duration)
	DirtyTireTracks.wetDependIndex = getIndexFromElement(DirtyTireTracks.wetDepends, DirtyTireTracks.wetDepend)
	DirtyTireTracks.minWetFactorIndex = getIndexFromElement(DirtyTireTracks.minWetFactors, DirtyTireTracks.minWetFactor)
	DirtyTireTracks.sizeFactorIndex = getIndexFromElement(DirtyTireTracks.sizeFactors, DirtyTireTracks.sizeFactor)
	DirtyTireTracks.activeOnFieldIndex = getIndexFromElement(DirtyTireTracks.activeOnFields, DirtyTireTracks.activeOnField)
	DirtyTireTracks.saveTracksIndex = getIndexFromElement(DirtyTireTracks.saveTrackss, DirtyTireTracks.saveTracks)
	
	self:saveToXmlDirtyTireTracks(self)
	DirtyTireTracksSetGlobalConfigEvent.sendEvent(self, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
end
function DirtyTireTracks:setVehicleConfig(currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	spec.currentConfig = currentConfig
	spec.duration =  duration
	spec.wetDepend = wetDepend
	spec.minWetFactor = minWetFactor
	spec.sizeFactor = sizeFactor
	spec.activeOnField = activeOnField
	spec.saveTracks = saveTracks
	
	spec.currentConfigIndex = getIndexFromElement(DirtyTireTracks.currentConfigs, spec.currentConfig)
	spec.durationIndex = getIndexFromElement(DirtyTireTracks.durations, spec.duration)
	spec.wetDependIndex = getIndexFromElement(DirtyTireTracks.wetDepends, spec.wetDepend)
	spec.minWetFactorIndex = getIndexFromElement(DirtyTireTracks.minWetFactors, spec.minWetFactor)
	spec.sizeFactorIndex = getIndexFromElement(DirtyTireTracks.sizeFactors, spec.sizeFactor)
	spec.activeOnFieldIndex = getIndexFromElement(DirtyTireTracks.activeOnFields, spec.activeOnField)
	spec.saveTracksIndex = getIndexFromElement(DirtyTireTracks.saveTrackss, spec.saveTracks)
	
	self:saveToXmlDirtyTireTracks(self, self:dttGetFullName(), spec.modActive)
	DirtyTireTracksSetVehicleConfigEvent.sendEvent(self, currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
end
function DirtyTireTracks:getHasDttImplement()
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
	local hasDtt = false
	if self.spec_attacherJoints ~= nil and self.spec_attacherJoints.attachedImplements ~= nil then
		for i,implement in pairs(self.spec_attacherJoints.attachedImplements) do
			if implement.object.spec_dirtyTireTracks ~= nil and implement.object.spec_dirtyTireTracks.modAllowed then
				hasDtt = true
			end
		end
	end
	return hasDtt
end
function DirtyTireTracks:dttGetFullName()
    local name = self:getName()
    local storeItem = g_storeManager:getItemByXMLFilename(self.configFileName)
    if storeItem ~= nil then
        local brand = g_brandManager:getBrandByIndex(storeItem.brandIndex)
        if brand ~= nil then
            name = brand.title .. " " .. name
        end
    end
    return name
end
function DirtyTireTracks:onReadStream(streamId, connection)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
    local modActive = streamReadBool(streamId)
    local modActiveGlobal = streamReadBool(streamId)
	if modActive ~= nil and modActiveGlobal ~= nil then
		self:toggleActiveDirtyTireTracks(modActive, modActiveGlobal, true)
	end
	
	local duration = streamReadFloat32(streamId)
	local wetDepend = streamReadBool(streamId)
	local minWetFactor = streamReadFloat32(streamId)
	local sizeFactor = streamReadFloat32(streamId)
	local activeOnField = streamReadBool(streamId)
	local saveTracks = streamReadBool(streamId)
	if duration ~= nil and wetDepend ~= nil and minWetFactor ~= nil and sizeFactor ~= nil and activeOnField ~= nil and saveTracks ~= nil then
		self:setGlobalConfig(duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, true)
	end
	
	local currentConfig = streamReadBool(streamId)
	local duration = streamReadFloat32(streamId)
	local wetDepend = streamReadBool(streamId)
	local minWetFactor = streamReadFloat32(streamId)
	local sizeFactor = streamReadFloat32(streamId)
	local activeOnField = streamReadBool(streamId)
	local saveTracks = streamReadBool(streamId)
	if currentConfig ~= nil and duration ~= nil and wetDepend ~= nil and minWetFactor ~= nil and sizeFactor ~= nil and activeOnField ~= nil and saveTracks ~= nil then
		self:setVehicleConfig(currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, true)
	end
end
function DirtyTireTracks:onWriteStream(streamId, connection)
	local spec = self.spec_dirtyTireTracks
	if not spec.modInitialized or not spec.modAllowed then
		return
	end
	
    streamWriteBool(streamId, spec.modActive)
    streamWriteBool(streamId, DirtyTireTracks.modActive)
    streamWriteFloat32(streamId, DirtyTireTracks.duration)
    streamWriteBool(streamId, DirtyTireTracks.wetDepend)
    streamWriteFloat32(streamId, DirtyTireTracks.minWetFactor)
    streamWriteFloat32(streamId, DirtyTireTracks.sizeFactor)
    streamWriteBool(streamId, DirtyTireTracks.activeOnField)
    streamWriteBool(streamId, DirtyTireTracks.saveTracks)
	streamWriteBool(streamId, spec.currentConfig)
	streamWriteFloat32(streamId, spec.duration)
    streamWriteBool(streamId, spec.wetDepend)
    streamWriteFloat32(streamId, spec.minWetFactor)
    streamWriteFloat32(streamId, spec.sizeFactor)
    streamWriteBool(streamId, spec.activeOnField)
    streamWriteBool(streamId, spec.saveTracks)
end

DirtyTireTracksToggleActiveEvent = {}
DirtyTireTracksToggleActiveEvent_mt = Class(DirtyTireTracksToggleActiveEvent, Event)

InitEventClass(DirtyTireTracksToggleActiveEvent, "DirtyTireTracksToggleActiveEvent")

function DirtyTireTracksToggleActiveEvent:emptyNew()
    local self = Event:new(DirtyTireTracksToggleActiveEvent_mt)
    self.className="DirtyTireTracksToggleActiveEvent"
    return self
end

function DirtyTireTracksToggleActiveEvent:new(object, modActive, modActiveGlobal)
	local self = DirtyTireTracksToggleActiveEvent:emptyNew()
	self.object = object
	self.modActive = modActive
	self.modActiveGlobal = modActiveGlobal
	return self
end

function DirtyTireTracksToggleActiveEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId)
    self.modActive = streamReadBool(streamId)
    self.modActiveGlobal = streamReadBool(streamId)
    self:run(connection)
end

function DirtyTireTracksToggleActiveEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object)
	streamWriteBool(streamId, self.modActive)
	streamWriteBool(streamId, self.modActiveGlobal)
end

function DirtyTireTracksToggleActiveEvent:run(connection)
	if self.object ~= nil then
		self.object:toggleActiveDirtyTireTracks(self.modActive, self.modActiveGlobal, true)
	end
	if not connection:getIsServer() then
		g_server:broadcastEvent(DirtyTireTracksToggleActiveEvent:new(self.object, self.modActive, self.modActiveGlobal), nil, connection, self.object)
	end
end

function DirtyTireTracksToggleActiveEvent.sendEvent(vehicle, modActive, modActiveGlobal, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(DirtyTireTracksToggleActiveEvent:new(vehicle, modActive, modActiveGlobal), nil, nil, vehicle)
		else
			g_client:getServerConnection():sendEvent(DirtyTireTracksToggleActiveEvent:new(vehicle, modActive, modActiveGlobal))
		end
	end
end

DirtyTireTracksSetGlobalConfigEvent = {}
DirtyTireTracksSetGlobalConfigEvent_mt = Class(DirtyTireTracksSetGlobalConfigEvent, Event)

InitEventClass(DirtyTireTracksSetGlobalConfigEvent, "DirtyTireTracksSetGlobalConfigEvent")

function DirtyTireTracksSetGlobalConfigEvent:emptyNew()
    local self = Event:new(DirtyTireTracksSetGlobalConfigEvent_mt)
    self.className="DirtyTireTracksSetGlobalConfigEvent"
    return self
end

function DirtyTireTracksSetGlobalConfigEvent:new(object, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks)
	local self = DirtyTireTracksSetGlobalConfigEvent:emptyNew()
	self.object = object
	self.duration = duration
	self.wetDepend = wetDepend
	self.minWetFactor = minWetFactor
	self.sizeFactor = sizeFactor
	self.activeOnField = activeOnField
	self.saveTracks = saveTracks
	return self
end

function DirtyTireTracksSetGlobalConfigEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId)
    self.duration = streamReadFloat32(streamId)
    self.wetDepend = streamReadBool(streamId)
    self.minWetFactor = streamReadFloat32(streamId)
    self.sizeFactor = streamReadFloat32(streamId)
    self.activeOnField = streamReadBool(streamId)
    self.saveTracks = streamReadBool(streamId)
    self:run(connection)
end

function DirtyTireTracksSetGlobalConfigEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object)
	streamWriteFloat32(streamId, self.duration)
	streamWriteBool(streamId, self.wetDepend)
	streamWriteFloat32(streamId, self.minWetFactor)
	streamWriteFloat32(streamId, self.sizeFactor)
	streamWriteBool(streamId, self.activeOnField)
	streamWriteBool(streamId, self.saveTracks)
end

function DirtyTireTracksSetGlobalConfigEvent:run(connection)
	if self.object ~= nil then
		self.object:setGlobalConfig(self.duration, self.wetDepend, self.minWetFactor, self.sizeFactor, self.activeOnField, self.saveTracks, true)
	end
	if not connection:getIsServer() then
		g_server:broadcastEvent(DirtyTireTracksSetGlobalConfigEvent:new(self.object, self.duration, self.wetDepend, self.minWetFactor, self.sizeFactor, self.activeOnField, self.saveTracks), nil, connection, self.object)
	end
end

function DirtyTireTracksSetGlobalConfigEvent.sendEvent(vehicle, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(DirtyTireTracksSetGlobalConfigEvent:new(vehicle, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks), nil, nil, vehicle)
		else
			g_client:getServerConnection():sendEvent(DirtyTireTracksSetGlobalConfigEvent:new(vehicle, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks))
		end
	end
end

DirtyTireTracksSetVehicleConfigEvent = {}
DirtyTireTracksSetVehicleConfigEvent_mt = Class(DirtyTireTracksSetVehicleConfigEvent, Event)

InitEventClass(DirtyTireTracksSetVehicleConfigEvent, "DirtyTireTracksSetVehicleConfigEvent")

function DirtyTireTracksSetVehicleConfigEvent:emptyNew()
    local self = Event:new(DirtyTireTracksSetVehicleConfigEvent_mt)
    self.className="DirtyTireTracksSetVehicleConfigEvent"
    return self
end

function DirtyTireTracksSetVehicleConfigEvent:new(object, currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks)
	local self = DirtyTireTracksSetVehicleConfigEvent:emptyNew()
	self.object = object
	self.currentConfig = currentConfig
	self.duration = duration
	self.wetDepend = wetDepend
	self.minWetFactor = minWetFactor
	self.sizeFactor = sizeFactor
	self.activeOnField = activeOnField
	self.saveTracks = saveTracks
	return self
end

function DirtyTireTracksSetVehicleConfigEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId)
    self.currentConfig = streamReadBool(streamId)
    self.duration = streamReadFloat32(streamId)
    self.wetDepend = streamReadBool(streamId)
    self.minWetFactor = streamReadFloat32(streamId)
    self.sizeFactor = streamReadFloat32(streamId)
    self.activeOnField = streamReadBool(streamId)
    self.saveTracks = streamReadBool(streamId)
    self:run(connection)
end

function DirtyTireTracksSetVehicleConfigEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object)
	streamWriteBool(streamId, self.currentConfig)
	streamWriteFloat32(streamId, self.duration)
	streamWriteBool(streamId, self.wetDepend)
	streamWriteFloat32(streamId, self.minWetFactor)
	streamWriteFloat32(streamId, self.sizeFactor)
	streamWriteBool(streamId, self.activeOnField)
	streamWriteBool(streamId, self.saveTracks)
end

function DirtyTireTracksSetVehicleConfigEvent:run(connection)
	if self.object ~= nil then
		self.object:setVehicleConfig(self.currentConfig, self.duration, self.wetDepend, self.minWetFactor, self.sizeFactor, self.activeOnField, self.saveTracks, true)
	end
	if not connection:getIsServer() then
		g_server:broadcastEvent(DirtyTireTracksSetVehicleConfigEvent:new(self.object, self.currentConfig, self.duration, self.wetDepend, self.minWetFactor, self.sizeFactor, self.activeOnField, self.saveTracks), nil, connection, self.object)
	end
end

function DirtyTireTracksSetVehicleConfigEvent.sendEvent(vehicle, currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(DirtyTireTracksSetVehicleConfigEvent:new(vehicle, currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks), nil, nil, vehicle)
		else
			g_client:getServerConnection():sendEvent(DirtyTireTracksSetVehicleConfigEvent:new(vehicle, currentConfig, duration, wetDepend, minWetFactor, sizeFactor, activeOnField, saveTracks))
		end
	end
end

DirtyTireTracksDeleteTracksEvent = {}
DirtyTireTracksDeleteTracksEvent_mt = Class(DirtyTireTracksDeleteTracksEvent, Event)

InitEventClass(DirtyTireTracksDeleteTracksEvent, "DirtyTireTracksDeleteTracksEvent")

function DirtyTireTracksDeleteTracksEvent:emptyNew()
    local self = Event:new(DirtyTireTracksDeleteTracksEvent_mt)
    self.className="DirtyTireTracksDeleteTracksEvent"
    return self
end

function DirtyTireTracksDeleteTracksEvent:new(object, current)
	local self = DirtyTireTracksDeleteTracksEvent:emptyNew()
	self.object = object
	self.current = current
	return self
end

function DirtyTireTracksDeleteTracksEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId)
    self.current = streamReadBool(streamId)
    self:run(connection)
end

function DirtyTireTracksDeleteTracksEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object)
	streamWriteBool(streamId, self.current)
end

function DirtyTireTracksDeleteTracksEvent:run(connection)
	if self.object ~= nil then
		if self.current then
			self.object:deleteTireTracksCurrent(true)
		else
			self.object:deleteTireTracks(false, true)
		end
	end
	if not connection:getIsServer() then
		g_server:broadcastEvent(DirtyTireTracksDeleteTracksEvent:new(self.object, self.current), nil, connection, self.object)
	end
end

function DirtyTireTracksDeleteTracksEvent.sendEvent(vehicle, current, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(DirtyTireTracksDeleteTracksEvent:new(vehicle, current), nil, nil, vehicle)
		else
			g_client:getServerConnection():sendEvent(DirtyTireTracksDeleteTracksEvent:new(vehicle, current))
		end
	end
end