dtrGui = {}

local dtrGui_mt = Class(dtrGui, ScreenElement)

function dtrGui:new(target, custom_mt)
    local self = ScreenElement:new(target, dtrGui_mt)
    self.returnScreenName = ""
    return self
end

function dtrGui:onOpen()
    dtrGui:superClass().onOpen(self)
	FocusManager:setFocus(self.backButton)
	if self.target ~= nil then
		self.dtrGuiHeader.text = g_i18n:getText('GUI_DTR_SETTINGS') .. ' (' .. self.target:dttGetFullName() .. ')'
	end
end

function dtrGui:onClose()
    dtrGui:superClass().onClose(self)
end

function dtrGui:onClickBack()
    dtrGui:superClass().onClickBack(self)
	DirtyTireTracks:guiClosed()
end

function dtrGui:onClickOk()
    dtrGui:superClass().onClickOk(self)
	DirtyTireTracks:settingsFromGui(self.target, self.duration:getState(), self.wetDepend:getState(), self.minWetFactor:getState(), self.sizeFactor:getState(), self.activeOnField:getState(), self.saveTracks:getState(), self.currentConfig:getState(), 
										self.durationCurrent:getState(), self.wetDependCurrent:getState(), self.minWetFactorCurrent:getState(), self.sizeFactorCurrent:getState(), self.activeOnFieldCurrent:getState())
    self:onClickBack()
end
function dtrGui:onClickDelete()
	self.target:deleteTireTracks(false, false)
end
function dtrGui:onClickDeleteCurrent()
	self.target:deleteTireTracksCurrent(false)
end

function dtrGui:setTarget(target)
	self.target = target
end
function dtrGui:onIngameMenuHelpTextChanged(element)
end;

function dtrGui:onCreateDtrGuiHeader(element)
	self.dtrGuiHeader = element
	element.text = g_i18n:getText('GUI_DTR_SETTINGS')
end
function dtrGui:onCreateDtrGuiHeaderGlobal(element)
	element.text = g_i18n:getText('GUI_DTR_GLOBAL')
end
function dtrGui:onCreateDtrGuiHeaderCurrent(element)
	element.text = g_i18n:getText('GUI_DTR_CURRENT')
end

function dtrGui:onCreateDuration(element)
    self.duration = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_DURATION')
	element.toolTipText = g_i18n:getText('GUI_DTR_DURATIONTOOLTIP')
    local durations = {}

    for i = 1, #DirtyTireTracks.durationTexts, 1 do
        durations[i] = DirtyTireTracks.durationTexts[i]
    end
	
    element:setTexts(durations)
end
function dtrGui:setDuration(indexDuration)
    self.duration:setState(indexDuration, false)
end

function dtrGui:onCreateWetDepend(element)
	self.wetDepend = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_WET_DEPEND')
	element.toolTipText = g_i18n:getText('GUI_DTR_WET_DEPEND_TOOLTIP')
    local wetDepends = {}

    for i = 1, #DirtyTireTracks.wetDependTexts, 1 do
        wetDepends[i] = DirtyTireTracks.wetDependTexts[i]
    end
	
    element:setTexts(wetDepends)
end
function dtrGui:setWetDepend(indexWetDepend)
    self.wetDepend:setState(indexWetDepend, false);
end

function dtrGui:onCreateMinWetFactor(element)
    self.minWetFactor = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_MIN_WET_FACTOR')
	element.toolTipText = g_i18n:getText('GUI_DTR_MIN_WET_FACTOR_TOOLTIP')
    local minWetFactors = {}

	for i = 1, #DirtyTireTracks.minWetFactorTexts, 1 do
        minWetFactors[i] = DirtyTireTracks.minWetFactorTexts[i]
    end
	
    element:setTexts(minWetFactors)
end
function dtrGui:setMinWetFactor(indexMinWetFactor)
    self.minWetFactor:setState(indexMinWetFactor, false)
end

function dtrGui:onCreateSizeFactor(element)
    self.sizeFactor = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_SIZE_FACTOR')
	element.toolTipText = g_i18n:getText('GUI_DTR_SIZE_FACTOR_TOOLTIP')
    local sizeFactors = {}

	for i = 1, #DirtyTireTracks.sizeFactorTexts, 1 do
       sizeFactors[i] = DirtyTireTracks.sizeFactorTexts[i]
    end
	
    element:setTexts(sizeFactors)
end
function dtrGui:setSizeFactor(indexSizeFactor)
    self.sizeFactor:setState(indexSizeFactor, false)
end

function dtrGui:onCreateActiveOnField(element)
    self.activeOnField = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_ACTIVE_ON_FIELD')
	element.toolTipText = g_i18n:getText('GUI_DTR_ACTIVE_ON_FIELD_TOOLTIP')
    local activeOnFields = {}

	for i = 1, #DirtyTireTracks.activeOnFieldTexts, 1 do
       activeOnFields[i] = DirtyTireTracks.activeOnFieldTexts[i]
    end
	
    element:setTexts(activeOnFields)
end
function dtrGui:setActiveOnField(indexActiveOnField)
    self.activeOnField:setState(indexActiveOnField, false)
end

function dtrGui:onCreateSaveTracks(element)
    self.saveTracks = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_SAVE_TRACKS')
	element.toolTipText = g_i18n:getText('GUI_DTR_SAVE_TRACKS_TOOLTIP')
    local saveTrackss = {}

	for i = 1, #DirtyTireTracks.saveTracksTexts, 1 do
       saveTrackss[i] = DirtyTireTracks.saveTracksTexts[i]
    end
	
    element:setTexts(saveTrackss)
end
function dtrGui:setSaveTracks(indexSaveTracks)
    self.saveTracks:setState(indexSaveTracks, false)
end

function dtrGui:onCreateCurrentConfig(element)
    self.currentConfig = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_CURRENT_CONFIG')
	element.toolTipText = g_i18n:getText('GUI_DTR_CURRENT_CONFIG_TOOLTIP')
    local currentConfigs = {}

	for i = 1, #DirtyTireTracks.currentConfigTexts, 1 do
       currentConfigs[i] = DirtyTireTracks.currentConfigTexts[i]
    end
	
    element:setTexts(currentConfigs)
	
end
function dtrGui:setCurrentConfig(indexCurrentConfig)
    self.currentConfig:setState(indexCurrentConfig, false)
end

function dtrGui:onCreateDurationCurrent(element)
    self.durationCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_DURATION')
	element.toolTipText = g_i18n:getText('GUI_DTR_DURATIONTOOLTIP')
    local durations = {}

    for i = 1, #DirtyTireTracks.durationTexts, 1 do
        durations[i] = DirtyTireTracks.durationTexts[i]
    end
	
    element:setTexts(durations)
end
function dtrGui:setDurationCurrent(indexDuration)
    self.durationCurrent:setState(indexDuration, false)
end

function dtrGui:onCreateWetDependCurrent(element)
	self.wetDependCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_WET_DEPEND')
	element.toolTipText = g_i18n:getText('GUI_DTR_WET_DEPEND_TOOLTIP')
    local wetDepends = {}

    for i = 1, #DirtyTireTracks.wetDependTexts, 1 do
        wetDepends[i] = DirtyTireTracks.wetDependTexts[i]
    end
	
    element:setTexts(wetDepends)
end
function dtrGui:setWetDependCurrent(indexWetDepend)
    self.wetDependCurrent:setState(indexWetDepend, false);
end

function dtrGui:onCreateMinWetFactorCurrent(element)
    self.minWetFactorCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_MIN_WET_FACTOR')
	element.toolTipText = g_i18n:getText('GUI_DTR_MIN_WET_FACTOR_TOOLTIP')
    local minWetFactors = {}

	for i = 1, #DirtyTireTracks.minWetFactorTexts, 1 do
        minWetFactors[i] = DirtyTireTracks.minWetFactorTexts[i]
    end
	
    element:setTexts(minWetFactors)
end
function dtrGui:setMinWetFactorCurrent(indexMinWetFactor)
    self.minWetFactorCurrent:setState(indexMinWetFactor, false)
end

function dtrGui:onCreateSizeFactorCurrent(element)
    self.sizeFactorCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_SIZE_FACTOR')
	element.toolTipText = g_i18n:getText('GUI_DTR_SIZE_FACTOR_TOOLTIP')
    local sizeFactors = {}

	for i = 1, #DirtyTireTracks.sizeFactorTexts, 1 do
       sizeFactors[i] = DirtyTireTracks.sizeFactorTexts[i]
    end
	
    element:setTexts(sizeFactors)
end
function dtrGui:setSizeFactorCurrent(indexSizeFactor)
    self.sizeFactorCurrent:setState(indexSizeFactor, false)
end

function dtrGui:onCreateActiveOnFieldCurrent(element)
    self.activeOnFieldCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_DTR_ACTIVE_ON_FIELD')
	element.toolTipText = g_i18n:getText('GUI_DTR_ACTIVE_ON_FIELD_TOOLTIP')
    local activeOnFields = {}

	for i = 1, #DirtyTireTracks.activeOnFieldTexts, 1 do
       activeOnFields[i] = DirtyTireTracks.activeOnFieldTexts[i]
    end
	
    element:setTexts(activeOnFields)
end
function dtrGui:setActiveOnFieldCurrent(indexActiveOnField)
    self.activeOnFieldCurrent:setState(indexActiveOnField, false)
end
function dtrGui:onCreateDelete(element)
    self.delete = element
	element.text = g_i18n:getText('GUI_DTR_DELETE_TRACKS')
end
function dtrGui:onCreateDeleteCurrent(element)
    self.delete = element
	element.text = g_i18n:getText('GUI_DTR_DELETE_TRACKS_CURRENT')
end

function dtrGui:onClickCurrentConfig(element)
	self.durationCurrent:setDisabled(not DirtyTireTracks.currentConfigs[self.currentConfig:getState()])
	self.wetDependCurrent:setDisabled(not DirtyTireTracks.currentConfigs[self.currentConfig:getState()])
	self.minWetFactorCurrent:setDisabled(not DirtyTireTracks.currentConfigs[self.currentConfig:getState()])
	self.sizeFactorCurrent:setDisabled(not DirtyTireTracks.currentConfigs[self.currentConfig:getState()])
	self.activeOnFieldCurrent:setDisabled(not DirtyTireTracks.currentConfigs[self.currentConfig:getState()])
end

function dtrGui:onClickResetButton()
    DirtyTireTracks:settingsResetGui()
end